/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordResponseCreatedContainers type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordResponseCreatedContainers{}

// CreateCveRecordResponseCreatedContainers struct for CreateCveRecordResponseCreatedContainers
type CreateCveRecordResponseCreatedContainers struct {
	Cna *CreateCveRecordResponseCreatedContainersCna `json:"cna,omitempty"`
}

// NewCreateCveRecordResponseCreatedContainers instantiates a new CreateCveRecordResponseCreatedContainers object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordResponseCreatedContainers() *CreateCveRecordResponseCreatedContainers {
	this := CreateCveRecordResponseCreatedContainers{}
	return &this
}

// NewCreateCveRecordResponseCreatedContainersWithDefaults instantiates a new CreateCveRecordResponseCreatedContainers object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordResponseCreatedContainersWithDefaults() *CreateCveRecordResponseCreatedContainers {
	this := CreateCveRecordResponseCreatedContainers{}
	return &this
}

// GetCna returns the Cna field value if set, zero value otherwise.
func (o *CreateCveRecordResponseCreatedContainers) GetCna() CreateCveRecordResponseCreatedContainersCna {
	if o == nil || IsNil(o.Cna) {
		var ret CreateCveRecordResponseCreatedContainersCna
		return ret
	}
	return *o.Cna
}

// GetCnaOk returns a tuple with the Cna field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponseCreatedContainers) GetCnaOk() (*CreateCveRecordResponseCreatedContainersCna, bool) {
	if o == nil || IsNil(o.Cna) {
		return nil, false
	}
	return o.Cna, true
}

// HasCna returns a boolean if a field has been set.
func (o *CreateCveRecordResponseCreatedContainers) HasCna() bool {
	if o != nil && !IsNil(o.Cna) {
		return true
	}

	return false
}

// SetCna gets a reference to the given CreateCveRecordResponseCreatedContainersCna and assigns it to the Cna field.
func (o *CreateCveRecordResponseCreatedContainers) SetCna(v CreateCveRecordResponseCreatedContainersCna) {
	o.Cna = &v
}

func (o CreateCveRecordResponseCreatedContainers) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordResponseCreatedContainers) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Cna) {
		toSerialize["cna"] = o.Cna
	}
	return toSerialize, nil
}

type NullableCreateCveRecordResponseCreatedContainers struct {
	value *CreateCveRecordResponseCreatedContainers
	isSet bool
}

func (v NullableCreateCveRecordResponseCreatedContainers) Get() *CreateCveRecordResponseCreatedContainers {
	return v.value
}

func (v *NullableCreateCveRecordResponseCreatedContainers) Set(val *CreateCveRecordResponseCreatedContainers) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordResponseCreatedContainers) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordResponseCreatedContainers) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordResponseCreatedContainers(val *CreateCveRecordResponseCreatedContainers) *NullableCreateCveRecordResponseCreatedContainers {
	return &NullableCreateCveRecordResponseCreatedContainers{value: val, isSet: true}
}

func (v NullableCreateCveRecordResponseCreatedContainers) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordResponseCreatedContainers) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


